Imports MySql.Data
Imports MySql.Data.MySqlClient

Partial Class Receiveserver
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Page.IsPostBack = False Then

            ' This code runs when this page loads, the company ID is recevied from the session variable "CompanyID" and
            ' the Asset type ID comes from the transfered Context.Items("AssetTypeID") by a Server.Transfer.
            ' The Asset type is selected from the AssetType table based on the supplied AssetTypeID from HiddenAssetTypeID.

            HiddenCompanyID.Value = Convert.ToString(Session("CompanyID"))
            HiddenAssetTypeID.Value = Context.Items("AssetTypeID")

            If Not HiddenAssetTypeID.Value = "" Then
                Try
                    Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                    Dim sql As String = "SELECT * FROM AssetType WHERE AssetTypeID = @AssetTypeID"

                    ' The Using block is used to call dispose (close) automatically even if there are an exception.
                    Using cn As New MySqlConnection(ConnString), _
                          cmd As New MySqlCommand(sql, cn)
                        cmd.Parameters.Add("@AssetTypeID", MySqlDbType.Int64).Value = HiddenAssetTypeID.Value

                        cn.Open()
                        ' The Using block is used to call dispose (close) automatically even if there are an exception.
                        Using reader As MySqlDataReader = cmd.ExecuteReader(System.Data.CommandBehavior.SingleRow)
                            While reader.Read()
                                txtTillgangstypID.Text = reader("TypeOwnID").ToString()
                                txtAssetTypeName.Text = reader("TypeName").ToString()
                                NoDepricationCheckBox.Checked = Convert.ToBoolean(reader("NoDeprication"))
                                txtAssetAccount.Text = reader("AssetAccount").ToString()
                                txtAckDeprication.Text = reader("AccDepAccount").ToString()
                                txtDepricationAccount.Text = reader("DepricationAccount").ToString()
                                txtProfitSaleAccount.Text = reader("ProfitSaleAccount").ToString()
                                txtLossSaleAccount.Text = reader("LossSaleAccount").ToString()
                            End While
                        End Using

                    End Using
                Catch ex As Exception
                    Response.Write(ex.Message)
                End Try
            Else
                ErrorMessageLabel.Text = "* You have to choose an asset first"
            End If
        End If
    End Sub
    Protected Sub btnChangeAssetType_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnChangeAssetType.Click

        ' This code runs when a user has clicked the button to change asset type and updates the post in the
        ' AssetTyp table with the changed data.

        If Not HiddenAssetTypeID.Value = "" Then

            Try
                Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                Dim sql As String = "UPDATE AssetType SET TypeOwnID = @TypeOwnID, TypeName = @TypeName, NoDeprication = @NoDeprication, AssetAccount = @AssetAccount, AccDepAccount = @AccDepAccount, DepricationAccount = @DepricationAccount, ProfitSaleAccount = @ProfitSaleAccount, LossSaleAccount = @LossSaleAccount WHERE AssetTypeID = @AssetTypeID"

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using cn As New MySqlConnection(ConnString), _
                      cmd As New MySqlCommand(sql, cn)
                    cmd.Parameters.Add("@TypeOwnID", MySqlDbType.VarChar, 50).Value = txtTillgangstypID.Text
                    cmd.Parameters.Add("@TypeName", MySqlDbType.VarChar, 50).Value = txtAssetTypeName.Text
                    cmd.Parameters.Add("@NoDeprication", MySqlDbType.Bit).Value = NoDepricationCheckBox.Checked
                    cmd.Parameters.Add("@AssetAccount", MySqlDbType.VarChar, 10).Value = txtAssetAccount.Text
                    cmd.Parameters.Add("@AccDepAccount", MySqlDbType.VarChar, 10).Value = txtAckDeprication.Text
                    cmd.Parameters.Add("@DepricationAccount", MySqlDbType.VarChar, 10).Value = txtDepricationAccount.Text
                    cmd.Parameters.Add("@ProfitSaleAccount", MySqlDbType.VarChar, 10).Value = txtProfitSaleAccount.Text
                    cmd.Parameters.Add("@LossSaleAccount", MySqlDbType.VarChar, 10).Value = txtLossSaleAccount.Text
                    cmd.Parameters.Add("@AssetTypeID", MySqlDbType.Int64).Value = HiddenAssetTypeID.Value

                    cn.Open()
                    cmd.ExecuteNonQuery()
                    Server.Transfer("List-assettypes.aspx")

                End Using
            Catch ex As MySqlException
                Response.Write(ex.Message)
            End Try
        Else
            ErrorMessageLabel.Text = "* You have to choose an asset first"
        End If
    End Sub
End Class
